<template>
    <nav
        class="v-breadcrumbs"
        role="navigation"
    >

        <ul
            class="v-breadcrumbs__list"
            itemscope
            itemtype="http://schema.org/BreadcrumbList"
        >

            <li
                v-if="showHome"
                itemprop="itemListElement"
                itemscope
                itemtype="http://schema.org/ListItem"
                class="v-breadcrumbs__item breadcrumbs__item--home"
            >

                <a
                    :href="homeUrl"
                    :title="homeHtmlTitle"
                    :aria-label="homeHtmlTitle"
                    @click.prevent="onLinkClick( homeUrl )"
                    class="v-breadcrumbs__link"
                    itemscope
                    itemtype="http://schema.org/Thing"
                    itemprop="item"
                >

                    <meta
                        itemprop="position"
                        content="1"
                    />

                    <span
                        itemprop="name"
                        v-html="homeText"
                    />

                </a>

            </li>

            <template v-for="(i, idx) in preparedItems">

                <li
                    :key="i.key"
                    class="v-breadcrumbs__item"
                    itemprop="itemListElement"
                    itemscope
                    itemtype="http://schema.org/ListItem"
                >

                    <a
                        v-if="idx < preparedItems.length - 1"
                        :href="i.url"
                        :title="i.htmlTitle || i.text"
                        :aria-label="i.htmlTitle || i.text"
                        @click.prevent="onLinkClick( i.url )"
                        class="v-breadcrumbs__link"
                        itemscope
                        itemtype="http://schema.org/Thing"
                        itemprop="item"
                    >

                        <meta
                            itemprop="position"
                            :content="i.position"
                        />

                        <span itemprop="name">{{ i.text }}</span>

                    </a>

                    <span
                        v-else
                        :title="hereHtmlTitle || i.text"
                        :aria-label="hereHtmlTitle || i.text"
                        aria-current="page"
                        itemscope
                        itemtype="http://schema.org/Thing"
                        itemprop="item"
                        class="v-breadcrumbs__here"
                    >

                        <meta
                            itemprop="position"
                            :content="i.position"
                        />

                        <span itemprop="name">{{ i.text }}</span>

                    </span>

                </li>

            </template>

        </ul>

    </nav>
</template>

<script>
export default {

    name: "vBreadcrumbs",

    props: {

        items:  {
            type: Array,
            default: () => [],
        },

        homeText: {
            type    : String,
            default : 'Home page',
        },

        homeHtmlTitle: {
            type    : String,
            default : 'Go to home page',
        },

        homeUrl: {
            type    : String,
            default : "/",
        },

        showHome: {
            type    : Boolean,
            default : true,
        },

        hereHtmlTitle: {
            type    : String,
            default : "You're here",
        },

    },

    methods: {
        onLinkClick( url ) {
            if ( !this.$router ) {
                window.location = url;

                return;
            }

            this.$router.push( url );
        },
    },

    computed: {
        preparedItems() {
            return this.items.map( ( i, idx ) => {
                let position = idx;

                if ( this.showHome ) {
                    position = idx + 1;
                }

                return Object.assign( {
                    position,
                    key : idx,
                }, i );
            } );
        },
    },

}
</script>
